-- WipEout on TIC-80???!! It most 
-- likely is possible! Here's just 
-- A rolling demo of a proof of 
-- conept made for CoLD SToRAGE
-- concert for Mountainbytes 2024!
--
-- by Suule

flr=math.floor
sin=math.sin
cos=math.cos
rand=math.random
sqrt=math.sqrt
abs=math.abs
pi=math.pi
add=table.insert
rem=table.remove
max=20
dst=600
spd=2
xx={}
yy={}
zz={}
tex={}
-- UV Maps
tex1={15,0,15,15,0,0,
      15,15,0,0,0,15}
tex2={31,0,31,15,16,0,
      31,15,16,0,16,15}

tex3={15,16,15,31,0,16,
      15,31,0,16,0,31}
tex4={31,16,31,31,16,16,
      31,31,16,16,16,31}

tex5={15,32,15,47,0,32,
      15,47,0,32,0,47}
tex6={31,32,31,47,16,32,
      31,47,16,32,16,47}

-- Generate textures

function createtextures()
 for i=0,255 do
  -- Upper
   if rand(0,15)>13 then
    poke4(0x8000+i,12)
   else 
    poke4(0x8000+i,13)
   end
   if rand(0,15)>13 then
    poke4(0x8000+i+1024,14)
   else
    poke4(0x8000+i+1024,13)   
   end  
 -- Middle
   if rand(0,15)==15 then
    poke4(0x8000+i+2048,13)
   else 
    poke4(0x8000+i+2048,14)
   end
   if rand(0,15)==15 then
    poke4(0x8000+i+3072,15)
   else
    poke4(0x8000+i+3072,14)   
   end 
 -- Lower
   if rand(0,15)==15 then
    poke4(0x8000+i+4096,14)
   else 
    poke4(0x8000+i+4096,15)
   end
   if rand(0,15)==15 then
    poke4(0x8000+i+5120,0)
   else
    poke4(0x8000+i+5120,15)   
   end 
 -- BG
   if rand(0,15)==15 then
    poke4(0x8000+i+6144,13)
   else 
    poke4(0x8000+i+6144,13)
   end
   if rand(0,15)==15 then
    poke4(0x8000+i+7168,13)
   else
    poke4(0x8000+i+7168,13)   
   end 
 end
end

function quad(x1,y1,x2,y2,x3,y3,x4,y4,c)
 tri(x1,y1,x2,y2,x3,y3,c)
 tri(x2,y2,x3,y3,x4,y4,c)
end 

function BOOT()
 for i=0,max do
  xx[i]=0
  yy[i]=0
  zz[i]=i*i*2
  tex[i]=i%2
  createtextures()
 end
 vbank(1)
 poke(0x3ff8,15)
 vbank(0)
end

function cycleit()
 for i=0,max do 
  zz[i]=zz[i]+i*i*0.0873   -- Normal speed
--  zz[i]=zz[i]+i*i*0.006  -- Speed for testing
 end
 -- To ensure the track is rolling,
 -- take out the last piece and put in
 -- a new one.
 if zz[max] > 700 then
  rem(zz,max+1)
  add(zz,1,0)
  rem(xx,max+1)
  add(xx,1,6*sin(t/10*pi/2)+2*sin(t/15*pi/2)+2*sin(t/23*pi/2))
  rem(yy,max+1)    
  add(yy,1,3*cos(t/10*pi/2))
  rem(tex,max+1)
  if tex[1]==0 then add(tex,1,1) else add(tex,1,0) end
 end
end

function showfield()
 for i=0,max-1 do
  if zz[i] < dst then
   -- Calculate perspective shifts
   -- for distance.
  	local prs=(dst)/(dst-zz[i])
   local prsn=(dst)/(dst-(zz[i+1]))
   if prs > 0 then
   -- Cast x and y of a track section 
   -- into perspective
    x=120+(xx[i])*prs
    y=48+(yy[i])*prs
    radius=30*prs
   end   
   if prsn > 0 then 
   -- Cast x and y of the next track
   -- section
    xn=120+xx[i+1]*prsn
    yn=48+yy[i+1]*prsn
    radiusn=30*prsn
   end 
   -- To make sure no perspective errors
   -- will occur, do a sanity check of
   -- zz
   if zz[i+1]<1000 then
   -- Draw BG  
   
    if tex[i]==0 then bgcol=14 else bgcol=15 end
    tri(x+radius,y-radius/2,
         240,y-radius/2,
         xn+radiusn,yn-radiusn/2,bgcol)

    tri(240,y-radius/2,
         xn+radiusn,yn-radiusn/2,
         240,yn-radiusn/2,
         bgcol)

    tri(x-radius,y-radius/2,
         0,y-radius/2,
         xn-radiusn,yn-radiusn/2,bgcol)

    tri(0,y-radius/2,
         xn-radiusn,yn-radiusn/2,
         0,yn-radiusn/2,
         bgcol)
  
-- Left Wall
    tri(x-radius,y,
         0,y,
         xn-radiusn,yn,bgcol)

    tri( 0,y,
         xn-radiusn,yn,
         0,yn,
         bgcol)
      
    if tex[i]==0 then
     curtex=tex3
    else 
     curtex=tex4
    end
-- Right Half-Floor
    ttri(x+radius/sqrt(2),y+radius/sqrt(2),
         x+radius/sqrt(3),y+1.5*radius/sqrt(3),
         xn+radiusn/sqrt(2),yn+radiusn/sqrt(2),
         curtex[1],curtex[2],
         curtex[3],curtex[4],
         curtex[5],curtex[6],
         0,-1,
         zz[i]/prs,zz[i]/prs,zz[i+1]/prsn)
    ttri(x+radius/sqrt(3),y+1.5*radius/sqrt(3),
         xn+radiusn/sqrt(2),yn+radiusn/sqrt(2),
         xn+radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),
         curtex[7],curtex[8],
         curtex[9],curtex[10],
         curtex[11],curtex[12],
         0,-1,
         zz[i]/prs,zz[i+1]/prsn,zz[i+1]/prsn)
-- Left Half-Floor
    ttri(x-radius/sqrt(2),y+radius/sqrt(2),
         x-radius/sqrt(3),y+1.5*radius/sqrt(3),
         xn-radiusn/sqrt(2),yn+radiusn/sqrt(2),
         curtex[1],curtex[2],
         curtex[3],curtex[4],
         curtex[5],curtex[6],
         0,-1,
         zz[i]/prs,zz[i]/prs,zz[i+1]/prsn)
    ttri(x-radius/sqrt(3),y+1.5*radius/sqrt(3),
         xn-radiusn/sqrt(2),yn+radiusn/sqrt(2),
         xn-radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),
         curtex[7],curtex[8],
         curtex[9],curtex[10],
         curtex[11],curtex[12],
         0,-1,
         zz[i]/prs,zz[i+1]/prsn,zz[i+1]/prsn)

    if tex[i]==0 then
     curtex=tex5
    else 
     curtex=tex6
    end
-- Right Floor
    ttri(x+radius/sqrt(3),y+1.5*radius/sqrt(3),
         x,y+radius,
         xn+radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),
         curtex[1],curtex[2],
         curtex[3],curtex[4],
         curtex[5],curtex[6],
         0,-1,
         zz[i]/prs,zz[i]/prs,zz[i+1]/prsn)
    ttri(x,y+radius,
         xn+radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),
         xn,yn+radiusn, 
         curtex[7],curtex[8],
         curtex[9],curtex[10],
         curtex[11],curtex[12],
         0,-1,
         zz[i]/prs,zz[i+1]/prsn,zz[i+1]/prsn)
-- Left Floor
    ttri(x-radius/sqrt(3),y+1.5*radius/sqrt(3),
         x,y+radius,
         xn-radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),
         curtex[1],curtex[2],
         curtex[3],curtex[4],
         curtex[5],curtex[6],
         0,-1,
         zz[i]/prs,zz[i]/prs,zz[i+1]/prsn)
    ttri(x,y+radius,
         xn-radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),
         xn,yn+radiusn, 
         curtex[7],curtex[8],
         curtex[9],curtex[10],
         curtex[11],curtex[12],
         0,-1,
         zz[i]/prs,zz[i+1]/prsn,zz[i+1]/prsn)
    if tex[i]==0 then
     curtex=tex1
    else 
     curtex=tex2
    end
-- Right Wall
    ttri(x+radius,y-radius/2,
         x+radius/sqrt(2),y+radius/sqrt(2),
         xn+radiusn,yn-radiusn/2,
         curtex[1],curtex[2],
         curtex[3],curtex[4],
         curtex[5],curtex[6],
         0,-1,
         zz[i]/prs,zz[i]/prs,zz[i+1]/prsn)
    ttri(x+radius/sqrt(2),y+radius/sqrt(2),
         xn+radiusn,yn-radiusn/2,
         xn+radiusn/sqrt(2),yn+radiusn/sqrt(2),
         curtex[7],curtex[8],
         curtex[9],curtex[10],
         curtex[11],curtex[12],
         0,-1,
         zz[i]/prs,zz[i+1]/prsn,zz[i+1]/prsn)
-- Left Wall         
    ttri(x-radius,y-radius/2,
         x-radius/sqrt(2),y+radius/sqrt(2),
         xn-radiusn,yn-radiusn/2,
         curtex[1],curtex[2],
         curtex[3],curtex[4],
         curtex[5],curtex[6],
         0,-1,
         zz[i]/prs,zz[i]/prs,zz[i+1]/prsn)
    ttri(x-radius/sqrt(2),y+radius/sqrt(2),
         xn-radiusn,yn-radiusn/2,
         xn-radiusn/sqrt(2),yn+radiusn/sqrt(2),
         curtex[7],curtex[8],
         curtex[9],curtex[10],
         curtex[11],curtex[12],
         0,-1,
         zz[i]/prs,zz[i+1]/prsn,zz[i+1]/prsn)
 -- Some lines to make it look better      
    line(x+radius,y-radius/2,xn+radiusn,yn-radiusn/2,14)
    line(x-radius,y-radius/2,xn-radiusn,yn-radiusn/2,14)
    line(x,y+radius,xn,yn+radiusn,15)
    line(x-radius/sqrt(3),y+1.5*radius/sqrt(3),xn-radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),15)
    line(x+radius/sqrt(3),y+1.5*radius/sqrt(3),xn+radiusn/sqrt(3),yn+1.5*radiusn/sqrt(3),15)
    line(x+radius/sqrt(2),y+radius/sqrt(2),xn+radiusn/sqrt(2),yn+radiusn/sqrt(2),15)
    line(x-radius/sqrt(2),y+radius/sqrt(2),xn-radiusn/sqrt(2),yn+radiusn/sqrt(2),15)
   else
   end
  end 
 end
 -- Shadow
 elli(xx[17]+120,yy[17]+115,24,3,0)
end


function rnd(arg)
 return flr(arg+0.5)
end

-- Draw a fake tunnel end
function tunnelend(ax,ay,bx,by)
 rect(0,35,240,150,14)
 quad(95+ax,35,120+ax,35,106+ax,75,120+ax,78,15)
 quad(145+ax,35,120+ax,35,134+ax,75,120+ax,78,15) 
 quad(100+bx,35,120+bx,35,110+bx,70,120+bx,74,0)
 quad(140+bx,35,120+bx,35,130+bx,70,120+bx,74,0) 
end

-- For generating cityscape
function drawhlight(x,y,wid,hei,scl,int,col1,col2)
 for i=0,hei do
  if i%int==0 then
   line(x,i+y,x+wid*scl, i+y, col1)
   line(x+wid*scl,i+y,x+wid,i+y, col2)
  end
 end
end
function drawvlight(x,y,wid,hei,scl,int,col1,col2)
 for i=0,wid do
  if i%int==0 then
   line(x+i,y,x+i,y+hei*scl, col1)
   line(x+i,y+hei*scl,x+i,y+hei, col2)
  end
 end
end
function drawdlight(x,y,wid,hei,int,siz,col)
 for i=0,wid do
  if i%int==0 then
   for j=0,hei do
    if j%int==0 then rect(x+i,y+j,siz,siz,col)end 
   end 
  end
 end
end

function cityscape(ax,ay)
 rect(0,0,240,35,7) 
 rect(72+ax/2,29,20,20,0)
 rect(155+ax/2,28,20,20,0)
 rect(165+ax/2,18,8,20,0)
 rect(85+ax/2,18,8,20,0)  
 rect(97+ax/2,24,8,20,0)
 rect(117+ax/2,24,8,20,0)
 rect(72+ax/2,24,8,20,0) 
 rect(62+ax/2,26,8,20,0)
 rect(160+ax/2,26,8,20,0) 
 rect(180+ax/2,26,8,20,0)  
 rect(77+ax/2,19,9,20,0) 
 drawvlight(77+ax/2,19,4,10,0.2,2,3,2)  
 drawvlight(81+ax/2,19,3,10,0.3,2,3,2)   
 drawvlight(77+ax/2,23,4,10,0.3,2,2,1)  
 drawvlight(81+ax/2,23,3,10,0.5,2,2,1)   
 rect(104+ax/2,2,10,33,0)
 drawvlight(104+ax/2,2,9,27,0.6,2,4,3)
 rect(110+ax/2,22,10,13,0)
 drawdlight(110+ax/2,23,6,11,3,2,3)
 drawdlight(110+ax/2,29,6,7,3,2,2)
 drawdlight(110+ax/2,23,6,2,3,2,4)  
 rect(120+ax/2,30,10,5,0) 
 rect(124+ax/2,12,8,23,0)
 drawdlight(124+ax/2,13,7,11,2,1,3)
 drawdlight(124+ax/2,17,7,11,2,1,2) 
 drawdlight(124+ax/2,21,7,6,2,1,1)
 rect(134+ax/2,25,20,10,0)
 circ(127+ax/2,28,6,0)
 elli(144+ax/2,25,10,4,0)
 drawhlight(134+ax/2,25,20,10,0.6,2,4,3) 
 rect(92+ax/2,15,8,23,0) 
 drawhlight(92+ax/2,15,6,21,0.3,2,11,10)
end

function drawhull(ax,ay,steer,fp)
 quad(fp*13+ax+steer,-14+ay,fp*9+ax+steer,-17+ay,
      fp*18+ax+2*steer/3,-10+ay,fp*13+ax+2*steer/3,-12+ay,2)
 quad(fp*9+ax+steer,-17+ay,fp*7+ax+steer,-18+ay,
      fp*13+ax+2*steer/3,-12+ay,fp*9+ax+2*steer/3,-14+ay,2)
 quad(fp*7+ax+steer,-18+ay,fp*4+ax+steer,-19+ay,
      fp*9+ax+2*steer/3,-14+ay,fp*6+ax+2*steer/3,-16+ay,2)
 quad(fp*4+ax+steer,-19+ay,ax+steer,-22+ay,
      fp*6+ax+2*steer/3,-16+ay,ax+2*steer/3,-19+ay,2)
 line(fp*4+ax+steer,-19+ay,fp*6+ax+2*steer/3,-16+ay,1)

 quad(fp*29+ax+steer/3,-3+ay, fp*21+ax+steer/3,-6+ay,
      fp*30+ax,2+ay,fp*28+ax,2+ay, 1)
 quad(fp*32+ax+steer/3,-4+ay,fp*29+ax+steer/3,-3+ay,
      fp*32+ax,0+ay,fp*30+ax,2+ay, 2)

 quad(fp*18+ax+2*steer/3,-10+ay,fp*13+ax+2*steer/3,-12+ay,
      fp*21+ax+steer/3,-6+ay,fp*15+ax+steer/3,-8+ay,12)
 quad(fp*13+ax+2*steer/3,-12+ay,fp*9+ax+2*steer/3,-14+ay,
      fp*15+ax+steer/3,-8+ay,fp*10+ax+steer/3,-10+ay,12)
 quad(fp*9+ax+2*steer/3,-14+ay,fp*6+ax+2*steer/3,-16+ay,
      fp*10+ax+steer/3,-10+ay,fp*7+ax+steer/3,-11+ay,12)
 quad(fp*6+ax+2*steer/3,-16+ay,ax+2*steer/3,-19+ay,
      fp*7+ax+steer/3,-11+ay,ax+steer/3,-14+ay,2)
 line(fp*6+ax+2*steer/3,-16+ay,fp*7+ax+steer/3,-11+ay,1)

 quad(fp*21+ax+steer/3,-6+ay,fp*15+ax+steer/3,-8+ay,
      fp*28+ax,2+ay,fp*24+ax,3+ay,2)
 quad(fp*15+ax+steer/3,-8+ay,fp*10+ax+steer/3,-10+ay,
      fp*24+ax,3+ay,fp*11+ax,-2+ay,2)
 quad(fp*10+ax+steer/3,-10+ay,fp*7+ax+steer/3,-11+ay,
      fp*11+ax,-2+ay,fp*7+ax,-3+ay,2)
 quad(fp*7+ax+steer/3,-11+ay,ax+steer/3,-14+ay,
      fp*7+ax,-3+ay,ax,-10+ay,2)
 line(fp*7+ax+steer/3,-11+ay,fp*7+ax,-3+ay,1)

 quad(fp*30+ax,2+ay,fp*28+ax,2+ay,
      fp*30+ax,6+ay,fp*28+ax,6+ay,1)
 quad(fp*28+ax,2+ay,fp*24+ax,3+ay,
      fp*28+ax,6+ay,fp*24+ax,4+ay,1)
 quad(fp*24+ax,3+ay,fp*11+ax,-2+ay,
      fp*24+ax,4+ay,fp*11+ax,1+ay,1)
 quad(fp*11+ax,-2+ay,fp*7+ax,-3+ay,
      fp*11+ax,1+ay,fp*2+ax,6+ay,1)
 quad(fp*7+ax,-3+ay,ax,-10+ay,
      fp*2+ax,6+ay,ax,5+ay,1)
 quad(fp*7+ax,-3+ay,ax,-10+ay,
      fp*2+ax,6+ay,ax,5+ay,1)
 
 quad(fp*2+ax+steer,-19+ay,ax+steer,-22+ay,
      fp*2+ax+2*steer/3,-17+ay,ax+steer/3,-14+ay,8)
end

function drawexhaust(ax,ay,fumex1,fumey1,fumex2,fumey2)
 circ(ax,ay,4,15)
 circ(ax,ay+1,3,14)
 circ(ax,ay+2,2,12)
 circ(ax,ay+2,2,12) 
 tri(ax-4,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,9)
 tri(ax+4,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,9) 
 tri(ax-3,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,10)
 tri(ax+3,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,10) 
 tri(ax-2,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,11)
 tri(ax+2,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,11) 
 tri(ax-1,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,12)
 tri(ax+1,ay+2,ax,ay+2,120+fumex1*3,fumey1+128,12) 
end

function HUD()
 timeprint=(time()+20000)//100/10
 for i=-1,1 do
  for j=-1,1 do
   print("POS",203+i,8+j,0,0,1)
   print("3",193+i,16+j,0,0,2)
   print("7",220+i,16+j,0,0,2)
   print("of",206+i,21+j,0,0,1) 
   print("LAP",203+i,32+j,0,0,1)
   print("1",193+i,40+j,0,0,2)
   print("2",220+i,40+j,0,0,2)
   print("of",206+i,45+j,0,0,1)
   print("THRUST",214+i,81+j,0,0,1,1)
   print("ENERGY",168+i,118+j,0,0,1,1)
   print("KPH",198+i,83+j,0,0,1,1)
   print(spd,156+i,83+j,0,0,2,1)
   print("LAP TIMES",13+i,100+j,0,0,1,1)
   print("1",5+i,110+j,0,0,1,1)
   if timeprint//60 < 10 then
    print(string.format("%d",timeprint//60),40+i,120+j,0,1,2)
   else
    if timeprint//60 <100 then
     print(string.format("%d",timeprint//60),28+i,120+j,0,1,2)
    else
     print(string.format("%d",timeprint//60),16+i,120+j,0,1,2)
    end
   end 
   print(":",52+i,120+j,0,1,2)
   clip(63,119,48,12) -- BUG PREVENTION!
   if timeprint%60<10 then
    print("0",64+i,120+j,0,1,2)   
    print(timeprint%60,76+i,120+j,0,1,2)
   else
    print(timeprint%60,64+i,120+j,0,1,2)
   end 
   clip()   
  end  
 end
 print("POS",203,8,4,0,1)
 print("3",193,16,12,0,2)
 print("7",220,16,12,0,2)
 print("of",206,21,4,0,1)
 print("LAP",203,32,4,0,1)
 print("1",193,40,12,0,2)
 print("2",220,40,12,0,2)
 print("of",206,45,4,0,1)
 print("THRUST",214,81,12,0,1,1)
 print("ENERGY",168,118,12,0,1,1) 
 print(spd,156,83,12,0,2,1)
 print("KPH",198,83,12,0,1,1) 
 print("LAP TIMES",13,100,12,0,1,1)
 print("1",5,110,12,0,1,1)
 if timeprint//60 < 10 then
  print(string.format("%d",timeprint//60),40,120,12,1,2)
 else
  if timeprint//60 <100 then
   print(string.format("%d",timeprint//60),28,120,12,1,2)
  else
   print(string.format("%d",timeprint//60),16,120,12,1,2)
  end
 end 
 print(":",52,120,12,1,2) 
 clip(63,119,48,12) -- BUG PREVENTION!
 if timeprint%60<10 then
  print("0",64,120,12,1,2)   
  print(timeprint%60,76,120,12,1,2)
 else
  print(timeprint%60,64,120,12,1,2)
 end
 clip()
 quad(170,95,210,95,165,105,205,105,4)
 quad(218,88,226,88,211,105,222,105,4)
 quad(210,95,218,88,205,105,211,105,4)  
 quad(226,88,235,88,222,105,228,103,4)

 quad(171,96,177,96,166,104,172,104,8)
 quad(179,96,185,96,174,104,180,104,8)
 quad(187,96,193,96,182,104,188,104,1)
 quad(195,96,201,96,190,104,196,104,1)
 quad(203,96,209,96,198,104,204,104,1)
 quad(211,96,217,90,206,104,210,104,2) 
 quad(219,89,225,89,212,104,218,104,15) 
 quad(227,89,233,89,220,104,226,102,15)
 quad(219,89,222,89,212,104,215,104,2)
 
 quad(158,107,198,107,163,116,203,116,4)
 quad(198,107,206,107,203,116,211,123,4)
 quad(206,107,214,107,211,123,219,123,4)
 quad(214,107,222,109,219,123,227,123,4)
 
 quad(159,108,165,108,164,115,170,115,2)
 quad(167,108,173,108,172,115,178,115,2)

 quad(175,108,181,108,180,115,186,115,1)
 quad(183,108,189,108,188,115,194,115,1)
 quad(191,108,197,108,196,115,202,115,1)

 quad(199,108,204,108,203,114,210,122,1) 

 quad(205,108,213,108,212,122,218,122,15)
 quad(214,108,221,110,219,122,225,122,15)
 
end


-- Let's make some Fake Copper!!! 
-- AMIGGGGAAAAAAAA STYLE!!!!!
function SCN(row)
 vbank(0)
 if row < 36 then
  if row%3 == 0 then
   poke(0x3FC0+3*7,140-3*row)
   poke(0x3FC0+3*7+1,54-row)
   poke(0x3FC0+3*7+2,164-3*row)
  end 
 end
end

function TIC()
 vbank(0)
 t=time()//60
 cls(0)
 cityscape(
 1*sin(t/10*pi/2)+0.25*sin(t/15*pi/2)+0.25*sin(t/23*pi/2),0)
 tunnelend(
 6*sin(t/10*pi/2)+2*sin(t/15*pi/2)+2*sin(t/23*pi/2),0,
 6*sin((t+1)/10*pi/2)+2*sin((t+1)/15*pi/2)+2*sin((t+1)/23*pi/2),0)
 cycleit() 
 showfield()
 spd=(110+3*sin(t/10*pi/2))//1
 drawhull(120+xx[16]+2*sin(t/40),98+yy[16],xx[16]/2,1)
 drawhull(120+xx[16]+2*sin(t/40),98+yy[16],xx[16]/2,-1) 
 drawexhaust(120+xx[17]+2*sin(t/40),98+yy[17],-xx[18]/4,yy[18]*3,-xx[19]/4,yy[19]*3)
 vbank(1)
 cls(15)
 HUD()
end

